

'================================================================================
' Utilize InternetExplorer with FreeBASIC, using AXSuite3.2
' The most up to date version of AXSuite3, containing install notes, is made available in this Thread:
' http://www.freebasic.net/forum/search.php?keywords=axsuite3&fid[0]=6

' 20016_02_27 : Initial Version
' 20016_02_29 : Utilize IHTMLDocument2
'================================================================================


' Includes
#Include Once "Windows.bi"					' Windows specific
#Include Once "Ax_lite.bi"						' AXSuite3.2
#Include Once "IWebBrowser2_invoke.bi"	' Generated this with AXSuite->CodeGeneration->Invoke
#Include Once "IWebBrowser2_pvti.bi"		' Generated this with AXSuite->CodeGeneration->vTable
#Include Once "mshtml_invoke.bi"			' Contains IHtmlDocument2


' Globals
Const IID_IWebBrowser2="{D30C1661-CDAF-11D0-8A3E-00C04FC9E26E}" ' ClassID

' -- First the IWebBrowser2 Object
Dim Shared As Any			Ptr	pBrowser   ' untyped object Ptr
Dim  As IWebBrowser2				oBrowser 	'  Object type (Invoke)
Dim  As IWebBrowser2_ 	Ptr	oBrowser_vt '  typed object ptr (vTable)

' -- Now for the IHTMLDocument2 Object
Dim  As IHTMLDocument2	Ptr	pDoc	' object Ptr
Dim  As IHTMLDocument2			oDoc	' invoke  Object


	' --  Global COM instance initialization , only one by project
	'   False if all Ocx controls are WindowLess controls , else True
	AxInit(TRUE)

	' -- get object control address with progid & ClassID
	pBrowser = AxCreate_Object( "InternetExplorer.Application" , IID_IWebBrowser2 )
	oBrowser_vt = pBrowser  ' If you want to use vtable address (optional)
	SetObj ( @oBrowser , pBrowser ) ' Obj from Ptr


	' -- Now lets configure the IWebBrowser2 Control :)
	axcall oBrowser.putVisible,vptr(TRUE)
	axcall oBrowser.putStatusBar, vptr(TRUE)
	axcall oBrowser.putStatusText, vptr("FreeBASIC IE !")


	' -- Navigate and wait for IE to load the Site  (via Invoke)
   axcall oBrowser.Navigate,vptr("www.facebook.de") ,vptr(0),vptr(0) ,vptr(0) ,vptr(0)
   'oBrowser_vt->lpvtbl->Navigate2(oBrowser_vt, vptr("google.com") ,vptr(0),vptr(0) ,vptr(0) ,vptr(0)) ' ' via vtable


	' -- It is undocument, why this is absolutely neccesary for late Binding! (pDoc)
	Ex: Dim vIndex As Variant : Vlet(vIndex, 1)


	' -- Now we (unfriendly) query the Browser till it signals readystate complete (4).
	' -- Events work nicer, But this is common behaviour in most VB code ive seen anyway...
	Dim IEReady As Integer
	Dim tmp As Integer
	
	Do
	  IEReady = variantv(AxGet(oBrowser.GetReadyState))
	  If IeReady <> tmp Then Print"IE Status:", IEReady
	  tmp = IeReady
	Loop Until IEReady = 4

	' -- Query the type of the returned document Object
	Dim sDocType As String
	sDocType = variants(AxGet(oBrowser.GetType))
	Print "Document type:" , sDocType

'====================================================================
' Now we will create and use IHtmlDocument2
'=====================================================================

	' -- Now we can be sure, that the Document Object exists...
	'	pDoc=objget(oBrowser_vt,"Document")->pdispval ' AXSuite v2 Style
	pDoc= ax_get( oBrowser_vt,"Document")->pdispval ' AXSuite v3 Style
	SetObj ( @oDoc , pDoc )   ' AXSuite v3 gt object from Ponter


	'------- Now we wait for (this Frames) Dcument readyState
	' This is not exactly implemented here, because it can fire for iFrames too.
	' again we should use Events. Im working on an implementation in my local Tree.

   Dim sDocState As String
	Do
	 'sDocState= variants(*objget(pDoc,"GetreadyState"))
	 sDocState = variants(AxGet(oDoc.GetreadyState)) 'AxS v3
	Loop Until sDocState ="complete"
	Print "Document readyState: ",sDocState

	Dim sDocTitle As String
	sDocTitle = variants(AxGet(oDoc.gettitle)) 'AxS v3
	'  sDocTitle= variants(*objget(pDoc,"title")) 'AxS v2
	Print "Current Document Title: ", sDocTitle

	Print "...Changing Document Title"
	axcall oDoc.puttitle, vptr("FreeBASIC IE !")
	
	sDocTitle = variants(AxGet(oDoc.gettitle)) 'AxS v3
	Print "Document Title is now: ", sDocTitle

	' -- Release Object
	Sleep (20000)
	'axcall oBrowser.quit
	 AxRelease_Object(pBrowser)     'release object

'================================================================================
'  Events exist for that ActiveX Control interface, if needed select Template with events !
'================================================================================
